var cvsTolxrSwitcher = function () {
	var prefManager = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefBranch);
	return {
		run : function () {

			var currentWindow = Components.classes["@mozilla.org/appshell/window-mediator;1"].getService(Components.interfaces.nsIWindowMediator).getMostRecentWindow("navigator:browser");
		
			var currBrowser = currentWindow.getBrowser();
			var currURL = currBrowser.currentURI.spec;
			var currtabornew = prefManager.getBoolPref("extensions.cvstolxrswitcher.newtab");
			var cvssearch="cmssw.cvs.cern.ch";
			var lxrsearch="cmslxr.fnal.gov";
			var siteSearch="";
			var PosSearch=-1;
			PosSearch=currURL.indexOf(cvssearch);
			if(PosSearch === -1) {
			  PosSearch=currURL.indexOf(lxrsearch);
			  if(PosSearch === -1) {
				siteSearch="none";
			  }
			  else {
				siteSearch="lxr";
			  }
			}
			else {
				siteSearch="cvs";
			}


			var head = content.document.getElementsByTagName("head")[0],
				style = content.document.getElementById("cvs-to-lxr-switcher-style");

			if (!style) {
				style = content.document.createElement("link");
				style.id = "cvs-to-lxr-switcher-style";
				style.type = "text/css";
				style.rel = "stylesheet";
				style.href = "chrome://cvstolxrswitcher/skin/skin.css";
				head.appendChild(style);
			}	

			if (siteSearch === "none") {
				alert("Not a cvs or lxr page");
			}
			else {
				var uri="";
				var cvsbase="http://cmssw.cvs.cern.ch/cgi-bin/cmssw.cgi/CMSSW/";
				var lxrbase="http://cmslxr.fnal.gov/lxr/source/";
				var cvsversion="?view=markup&pathrev=";				
				var lxrversion="?v=";				
//				alert("it's a cvs or lxr page");

				if (siteSearch === "cvs") {
					if(currURL.indexOf("?")===-1 ){
						uri = uri.concat(lxrbase,currURL.substr(49));
					}
					else {
						if(currURL.indexOf("pathrev=")===-1 ){
							uri = uri.concat(lxrbase,currURL.substring(49,currURL.indexOf("?")));
						}
						else{
							uri = uri.concat(lxrbase,currURL.substring(49,currURL.indexOf("?")),lxrversion,currURL.substring(currURL.indexOf("pathrev=")+8));
						}
					}
				}
				else { // (siteSearch === "lxr") {
					if(currURL.indexOf("?")===-1 ){
						uri = uri.concat(cvsbase,currURL.substr(34));
					}
					else {
						if(currURL.indexOf("v=")===-1){ 
						uri = uri.concat(cvsbase,currURL.substring(34,currURL.indexOf("?")));
						}
						else {
						uri = uri.concat(cvsbase,currURL.substring(34,currURL.indexOf("?")),cvsversion,currURL.substring(currURL.indexOf("v=")+2));
						}
					}
				}

				if(currtabornew){
					getBrowser().addTab(uri);
				}
				else {	openUILinkIn(uri,"current");
				}
			}
		}
	};
}();
//window.addEventListener("load", cvsTolxrSwitcher.init, false);
